#pragma once
#include <math.h>

//*********************************************************************************************************
//	Gx[v̏
enum{
	ENV_ATTACK,
	ENV_DECAY,
	ENV_SUSTAIN,
	ENV_RELEASE,
	ENV_OFF
};

//*********************************************************************************************************
//	Gx[vWFl[^NX
class CEnvGen
{
protected:
	float sampleRate;	//	Tv[g@44.1khzŒ

public:
	inline CEnvGen(void);
	inline ~CEnvGen(void);

	//	
	inline void init();

	//	ʎ擾
	inline float getGain(float elapsedFrames);

	//	X^[g
	inline void Start();

	//	[XX^[g
	inline void ReleaseStart(float);

	int status;	//	
	float gain, releaseVolume;	//	{[
	float releaseFrame;	//	[Xt[

	//	ADSR֘A
	inline void setADSR(float Attack, float Decay, float Sustain, float Release);
	inline void setA(float Attack);
	inline void setD(float Decay);
	inline void setS(float Sustain);
	inline void setR(float Relase);

	float A;	//	A^bN^C		0.0f`1.0f 0msec8999msec@0t[396855.9t[i44.1khzŒj
	float D;	//	fBPC^C		0.0f`1.0f 0msec8999msec@0t[396855.9t[i44.1khzŒj
	float S;	//	TXeBCg	0.0f`1.0f 0100
	float R;	//	[X^C		0.0f`1.0f 0msec8999msec@0t[396855.9t[i44.1khzŒj
};

//*********************************************************************************************************
CEnvGen::CEnvGen(void)
{
	init();
}

//*********************************************************************************************************
CEnvGen::~CEnvGen(void)
{
}

//*********************************************************************************************************
//	
void CEnvGen::init()
{
	sampleRate = 44100.0f;
	setADSR(0.0f, 0.0f, 1.0f, 0.0f);
	status = ENV_OFF;
	releaseFrame = 0.0f;
	gain = releaseVolume = 0.0f;
}

//*********************************************************************************************************
//	X^[g
void CEnvGen::Start()
{
	status = ENV_ATTACK;
};

//*********************************************************************************************************
//	[XX^[gFL[It
void CEnvGen::ReleaseStart(float frame){
	status = ENV_RELEASE;
	releaseFrame = frame;
	releaseVolume = gain;
}

//*********************************************************************************************************
//	{[擾
float CEnvGen::getGain(float elapsedFrames)
{
	switch (status){
	case ENV_OFF:
		gain = 0.0f;
		return 0.0f;
		break;
	case ENV_ATTACK:
		if (A == 0.0f){
			gain = 1.0f;
			status = ENV_DECAY;
		}
		else{
			gain = elapsedFrames / A;
			if (A <= elapsedFrames){
				status = ENV_DECAY;
			}
		}
		break;
	case ENV_DECAY:
		if (D == 0.0f){
			gain = S;
			status = ENV_SUSTAIN;
		}
		else{
			gain = (elapsedFrames - A) / D;
			gain = 1.0f - gain;
			gain = (1.0f - S) * gain;
			gain += S;
			if (A + D <= elapsedFrames){
				status = ENV_SUSTAIN;
				gain = S;
			}
		}
		break;
	case ENV_SUSTAIN:
		gain = S;
		break;
	case ENV_RELEASE:
		gain = releaseVolume * (1.0f - (elapsedFrames - releaseFrame) / R);
		if (R <= elapsedFrames - releaseFrame){
			status = ENV_OFF;
		}
		break;
	}

	if (gain > 1.0f)	gain = 1.0f;
	if (gain < 0.0f)	gain = 0.0f;

	return gain;
}

//*********************************************************************************************************
//	ADSRݒ
//	0`1.0ft[ɕϊ
void CEnvGen::setADSR(float Attack, float Decay, float Sustain, float Release)
{
	setA(Attack);
	setD(Decay);
	setS(Sustain);
	setR(Release);
}

void CEnvGen::setA(float Attack)
{
	A = (float)(((pow(10, (Attack * 20) / 20.0) - 1.0) * 1000.0) / (1000.0 / sampleRate));
}
void CEnvGen::setD(float Decay)
{
	D = (float)(((pow(10, (Decay * 20) / 20.0) - 1.0) * 1000.0) / (1000.0 / sampleRate));
}
void CEnvGen::setS(float Sustain)
{
	S = Sustain;
}
void CEnvGen::setR(float Release)
{
	R = (float)(((pow(10, (Release * 20) / 20.0) - 1.0) * 1000.0) / (1000.0 / sampleRate));
}
