#define _CRT_SECURE_NO_DEPRECATE 1
#pragma once
#include <math.h>
#include "CEnvGen.h"

enum{
	VOICE_STATE_OFF,
	VOICE_STATE_ON,
	VOICE_STATE_RELEASE
};

//*********************************************************************************************************
class CVoice
{
protected:
	float elapsedFrames; //IV[^n߂Ăo߂t[

	int   status; //IV[^̏ꍇTrue
	double   noteNo; //IV[^̉

	float volume;
	float releaseVolume;

	float sampleRate;	//Tv[g(ftHg 44100)

public:
	inline CVoice(void);
	inline ~CVoice(void);

	//	
	inline void init();

	//	݂̃IV[^̐UԂ
	inline float amplitude();

	//	IV[^̏ԂXV
	inline void  update();

	//	JnA~
	inline void start(int note);
	inline void stop();

	//	IV[^̏Ԃ擾
	inline int  getStatus() { return status; };
	inline int  getNoteNo() { return (int)noteNo; };
	inline float getElapsedFrames() { return elapsedFrames; };

	//	Gx[vWFl[^
	CEnvGen envgen;
};

CVoice::CVoice()
{
	// {
	init();
}

CVoice::~CVoice()
{
}

//*********************************************************************************************************
void CVoice::init()
{
	// oϐ
	elapsedFrames = 0.0;
	status = VOICE_STATE_OFF;
	noteNo = 0;
	sampleRate =44100.0f;
	envgen.init();
}

//*********************************************************************************************************
float CVoice::amplitude()
{
	// IV[^̐UԂ
	if(status != VOICE_STATE_OFF)
	{
		// IV[^̏ԂON̎
		float pi = 3.14159265f;

		// m[gNogvZ
		float freq = (float)(440.0 * pow(2.0, (noteNo - 69.0)/12.0));;

		// ݂̐UʂԂ
		return (float)(volume * sin(2.0 * pi * freq * elapsedFrames / sampleRate));
	}
	else
	{
		// IV[^̏ԂOFF̎

		// 0Ԃ
		return 0.0f;
	}
}

//*********************************************************************************************************
void  CVoice::update()
{
	// oߎԂi߂
	if (status != VOICE_STATE_OFF)
	{
		elapsedFrames += 1.0f;

		volume = envgen.getGain(elapsedFrames);
		if (status == VOICE_STATE_RELEASE && volume <= 0.0f)
		{
			elapsedFrames = 0.0;
			status = VOICE_STATE_OFF;
		}
	}
}

//*********************************************************************************************************
void CVoice::start(int note)
{
	elapsedFrames = 0.0;
	status = VOICE_STATE_ON;
	noteNo = note;
	envgen.Start();
}

//*********************************************************************************************************
void CVoice::stop()
{
	status = VOICE_STATE_RELEASE;
	releaseVolume = volume;
	envgen.ReleaseStart(elapsedFrames);
}
