#define _CRT_SECURE_NO_DEPRECATE 1

#include <stdio.h>
#include <stdlib.h>
#include "resource.h"

#include "audioeffectx.h"
#include <aeffguieditor.h>
#include "vstcontrols.h"

//---------------------------------------------------------------------------
//	8bittHg\NX
class FONT : public CView
{
private:
	class CBitmap *Screen;

public:
	CKnob**	Pknob;	//	tHg\ׂ̃mũ|C^
	void  PrintFont(CDrawContext *context, int x, int y, char* str);
	void  draw(CDrawContext *context);
	void update(CDrawContext *context);
	~FONT(void);
	FONT(CRect &size);
};

//---------------------------------------------------------------------------
FONT::FONT(CRect &size) : CView(size)
{
	Screen = new class CBitmap(BITMAP_FONT);
}

//---------------------------------------------------------------------------
FONT::~FONT(void)
{
	Screen->forget();
}

//---------------------------------------------------------------------------
//	`
void  FONT::draw(CDrawContext *context)
{
	//	VZ\
	PrintFont(context, 8, 8, "FM trial");

	//	p[^\
	PrintFont(context, 8, 28, " A   D   S   R");

	//	\
	char str[256];
	CRect rect;

	for (int index = 0; index < 4; index++){
		float value = Pknob[index]->getValue();
		Pknob[index]->getViewSize(rect);
		sprintf(str, "%3d", (int)(value * 127));
		PrintFont(context, rect.left, rect.top+24, str);
	}
}

//---------------------------------------------------------------------------
//	XV
void FONT::update(CDrawContext *context)
{
	draw(context);
}

//---------------------------------------------------------------------------
//	8bittHg摜؂oĕ\
void  FONT::PrintFont(CDrawContext *context, int x, int y, char* str)
{
	CRect SRect, DRect;

	for (int i = 0; i < (int)strlen(str); i++){
		int tx = str[i] % 16;
		int ty = (str[i] / 16) + 1;
		CPoint SPoint(tx * 8, ty * 8);
		DRect = CRect(x + (i * 8), y, x + (i * 8) + 8, y + 8);
		Screen->draw(context, DRect, SPoint);
	}
}

// ============================================================================================
// VST GUINX
// ============================================================================================
class VstGui4 : public AEffGUIEditor, CControlListener
{
public:
	VstGui4(void* effect);
	virtual ~VstGui4();

	//	VST GUI܂֐Q
	virtual bool open(void *ptr);
	virtual void close();
	virtual void idle();
	virtual void update(void);
	virtual void valueChanged(CControl *pControl);
	virtual void setParameter(VstInt32 index, float value);

	//	muݒ
	inline void SetKnob(int, long, long, CBitmap*);

	//	GtFNgpmu
	CKnob*		Pknob[MY_VST_PARAMETER_NUM];

	//	ReLXg
	CDrawContext *context;

	//	tHg`p
	FONT *pFont;

protected:
	// eLXgx
	CTextLabel* textLabel;
};

// ============================================================================================
//	RXgN^
VstGui4::VstGui4(void* effect)	: AEffGUIEditor((AudioEffect*)effect)
{
	// GUIWindowsTCYݒ
	rect.left = 0;
	rect.top = 0;
	rect.right = 512;
	rect.bottom = 256;
}

// ============================================================================================
//	fXgN^
VstGui4::~VstGui4()
{

}

// ============================================================================================
//	muݒu
void VstGui4::SetKnob(int iNum, long x, long y, CBitmap* knobBack)
{
	// mȗ傫ݒ
	CRect knobsize(0, 0, knobBack->getWidth(), knobBack->getHeight());

	// müʒuݒ
	knobsize.offset(x, y);

	// c(ʒu0.0Aʒu1.0)̃mu쐬B
	Pknob[iNum] = new CKnob(knobsize, this, iNum, knobBack, NULL, CPoint(0, 0));

	//	Sƃnh܂ł̒
	Pknob[iNum]->setInsetValue(1);

	// ݂̒l擾
	Pknob[iNum]->setValue(effect->getParameter(iNum));

	// muframeɒǉ
	frame->addView(Pknob[iNum]);
}

// ============================================================================================
//	GUII[v
bool VstGui4::open(void *ptr)
{
	AEffGUIEditor::open(ptr);

	//	t[쐬
	CRect size(rect.left, rect.top, rect.right, rect.bottom);
	CFrame* cframe = new CFrame(size, ptr, this);
	this->frame = cframe;

	//	ReLXg擾
	context = frame->createDrawContext();

	// -----------------------------------------------------------------
	//	8bittHgNXt[ɐݒ
	pFont = new class FONT(size);
	frame->addView(pFont);
	pFont->Pknob = Pknob;

	// -----------------------------------------------------------------
	//	muzu
	CBitmap *knobBMP = new CBitmap(BITMAP_KNOB);
	for (int i = 0; i < 4; i++){
		SetKnob(i, i*32+8, 40, knobBMP);
	}
	knobBMP->forget();

	return true;
}

// ============================================================================================
//	p[^ύXꂽ
void VstGui4::valueChanged(CControl *pControl)
{
	// ǂ̃p[^[삳ꂽ擾B
	VstInt32 index = pControl->getTag();

	// p[^[̒l擾B
	float value = pControl->getValue();

	// 擾lp[^[ɔf
	this->setParameter(index, value);

	//	`
	if (frame){
		frame->draw(0);
	}
}

// ============================================================================================
//	p[^ɔf
void VstGui4::setParameter(VstInt32 index, float value)
{
	//	muɒlݒ
	Pknob[index]->setValue(value);

	//	GtFN^[̒lύX
	effect->setParameterAutomated(index, value);
}

// ============================================================================================
void VstGui4::update()
{
	if (frame){
		frame->draw(0);
		frame->setDirty();
	}
}

// ============================================================================================
//	100msecƂɌĂ΂
void VstGui4::idle()
{
	AEffGUIEditor::idle();

	return;
}

// ============================================================================================
void VstGui4::close()
{
	if (frame)
	{
		delete frame;
	}
	frame = 0;
}